//////////////////////// Includes ////////////////////////////////////////////

#include "stdafx.h"
#include "popwatch.h"
#include "DlgAccount.h"



//////////////////////// Macros / Defines ////////////////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//////////////////////// Implementation //////////////////////////////////////

CDlgAccount::CDlgAccount(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAccount::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAccount)
	m_sPassword = _T("");
	m_sPop3Server = _T("");
	m_sUsername = _T("");
	m_sAccountName = _T("");
	m_sWaveFile = _T("");
	m_bSSL = FALSE;
	m_nPort = 0;
	m_bDisable = FALSE;
	//}}AFX_DATA_INIT
  m_nPort = 110;
}

void CDlgAccount::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAccount)
	DDX_Text(pDX, IDC_PASSWORD, m_sPassword);
	DDX_Text(pDX, IDC_POP3_SERVER, m_sPop3Server);
	DDX_Text(pDX, IDC_USERNAME, m_sUsername);
	DDX_Text(pDX, IDC_POP3_ACCOUNT_NAME, m_sAccountName);
	DDX_Text(pDX, IDC_WAVEFILE, m_sWaveFile);
	DDX_Check(pDX, IDC_SSL, m_bSSL);
	DDX_Text(pDX, IDC_PORT, m_nPort);
	DDX_Check(pDX, IDC_DISABLE, m_bDisable);
	//}}AFX_DATA_MAP
  DDX_FilenameControl(pDX, IDC_WAVEFILE, m_ctrlWaveFile, GF_FILEMUSTEXIST, _T("Please specify a sound file to play"), _T("Wave Files (*.wav)|*.wav||"));

  if (pDX->m_bSaveAndValidate)
  {
	  if (m_sAccountName.IsEmpty())
    {
      AfxMessageBox(_T("Please enter a valid Name"));
      pDX->PrepareEditCtrl(IDC_POP3_ACCOUNT_NAME);
      pDX->Fail();
    }

    BOOL bUnique = TRUE;
    for (int i=0; i<m_sExistingAccountNames.GetSize() && bUnique; i++)
      bUnique = (m_sAccountName.CompareNoCase(m_sExistingAccountNames.GetAt(i)) != 0);
	  if (!bUnique)
    {
      AfxMessageBox(_T("Please enter a unique Name"));
      pDX->PrepareEditCtrl(IDC_POP3_ACCOUNT_NAME);
      pDX->Fail();
    }
 
	  if (m_sPop3Server.IsEmpty())
    {
      AfxMessageBox(_T("Please enter a valid POP3 Server"));
      pDX->PrepareEditCtrl(IDC_POP3_SERVER);
      pDX->Fail();
    }

    if (m_sUsername.IsEmpty())
    {
      AfxMessageBox(_T("Please enter a valid Username"));
      pDX->PrepareEditCtrl(IDC_USERNAME);
      pDX->Fail();
    }
  }
}

BEGIN_MESSAGE_MAP(CDlgAccount, CDialog)
	//{{AFX_MSG_MAP(CDlgAccount)
	ON_BN_CLICKED(IDC_SSL, OnSsl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CDlgAccount::OnSsl() 
{
  CDataExchange DX(this, TRUE);
  DDX_Check(&DX, IDC_SSL, m_bSSL);

  CDataExchange DX2(this, FALSE);
  if (m_bSSL)
  {
    m_nPort = 995;
    DDX_Text(&DX2, IDC_PORT, m_nPort);
  }  	
  else
  {
    m_nPort = 110;
    DDX_Text(&DX2, IDC_PORT, m_nPort);
  }  	
}
