#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "MainFrm.h"

class CPopWatchApp : public CWinApp
{
public:
  CPopWatchApp();

	//{{AFX_VIRTUAL(CPopWatchApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

  BOOL   IsProcessRunning(HANDLE hProcess);
  HANDLE StartProcessGettingProcessHandle(const TCHAR* pszCommandLine);
  BOOL   StartProcessWithoutGettingProcessHandle(const TCHAR* pszCommandLine);

//Public variables
  int m_nInterval;
  CStringArray m_sPasswords;
  CStringArray m_sPop3Servers;
  CStringArray m_sUsernames;
  CStringArray m_sAccountNames;
  CStringArray m_sWaveFiles;
  CDWordArray  m_nPorts;
  CDWordArray  m_bSSLs;
  CDWordArray  m_bDisables;
  BOOL         m_bCheckUsingRas;
  BOOL         m_bWin2k;
  BOOL         m_bBalloon;
  HANDLE       m_hSpawnedProcess;
  BOOL         m_bOneInstance;
  CString      m_sProgramToRun;
  CString      m_sWaveFileToPlay;

protected:
	//{{AFX_MSG(CPopWatchApp)
	afx_msg void OnAppAbout();
	afx_msg void OnAppSettings();
	afx_msg void OnHelp();
	afx_msg void OnAppChecknow();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

  TCHAR*  EncryptString(const CString& sString);
  CString DecryptString(const BYTE* pData, int nSize);
  void    LoadSettings();
  void    SaveSettings();

//OpenSSL stuff
  static CCriticalSection* m_pOpenSSLCritSections;
  static void __cdecl OpenSSLLockingCallback(int mode, int type, const char* file, int line);
};

CPopWatchApp* GetApp();
CMainFrame* GetMainFrame();