#ifndef __SETTINGS_H__
#define __SETTINGS_H__

#include "ddxfile.h"

class CGeneralSettingsPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CGeneralSettingsPage)

public:
	CGeneralSettingsPage();
	~CGeneralSettingsPage();

	//{{AFX_DATA(CGeneralSettingsPage)
	enum { IDD = IDD_GENERAL_SETTINGS };
	CListBox	m_ctrlAccounts;
	CSpinButtonCtrl	m_ctrlSpinInterval;
	int		m_nInterval;
	BOOL	m_bCheckUsingRas;
	BOOL	m_bBalloon;
	CString	m_sProgram;
	CString	m_sWaveFile;
	BOOL	m_bOneInstance;
	//}}AFX_DATA
  CGetFilenameControl m_ctrlProgram;
  CGetFilenameControl m_ctrlWaveFile;

  CStringArray m_sPasswords;
  CStringArray m_sPop3Servers;
  CStringArray m_sUsernames;
  CStringArray m_sAccountNames;
  CStringArray m_sWaveFiles;
  CDWordArray  m_nPorts;
  CDWordArray  m_bSSLs;
  CDWordArray  m_bDisables;

protected:
	//{{AFX_VIRTUAL(CGeneralSettingsPage)
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

  CString CreateNewAccountName();

	//{{AFX_MSG(CGeneralSettingsPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnAdd();
	afx_msg void OnDelete();
	afx_msg void OnEdit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class CSettingsPropertySheet : public CPropertySheet
{
public:
	CSettingsPropertySheet(CWnd* pWndParent = NULL);
	virtual ~CSettingsPropertySheet();

	CGeneralSettingsPage m_Page1;

protected:
	DECLARE_DYNAMIC(CSettingsPropertySheet)

	//{{AFX_VIRTUAL(CSettingsPropertySheet)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CSettingsPropertySheet)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif	//__SETTINGS_H__
